## cntlm 0.35.1

=== Makefile ===
#
# You can tweak these three variables to make things install where you
# like, but do not touch more unless you know what you are doing. ;)
#
SYSCONFDIR=/usr/local/etc
BINDIR=/usr/local/bin
MANDIR=/usr/local/man

#
# Careful now...
# __BSD_VISIBLE is for FreeBSD AF_* constants
# _ALL_SOURCE is for AIX 5.3 LOG_PERROR constant
#
CC=gcc
OBJS=utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o proxy.o 
CFLAGS=$(FLAGS) -std=c99 -Wall -pedantic -O3 -D__BSD_VISIBLE -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112 -D_ISOC99_SOURCE -D_REENTRANT -DVERSION=\"`cat VERSION`\"
LDFLAGS=-lpthread
NAME=cntlm
VER=`cat VERSION`
DIR=`pwd`

$(NAME): configure-stamp $(OBJS)
	@echo "Linking $@"
	@$(CC) $(CFLAGS) -o $@ $(OBJS) $(LDFLAGS)

proxy.o: proxy.c
	@echo "Compiling $<"
	@if [ -z "$(SYSCONFDIR)" ]; then \
		$(CC) $(CFLAGS) -c proxy.c -o $@; \
	else \
		$(CC) $(CFLAGS) -DSYSCONFDIR=\"$(SYSCONFDIR)\" -c proxy.c -o $@; \
	fi

.c.o:
	@echo "Compiling $<"
	@$(CC) $(CFLAGS) -c -o $@ $<

install: $(NAME)
	# AIX?
	if [ -f /usr/bin/oslevel ]; then \
		install -O root -G system -M 755 -S -f $(BINDIR) $(NAME); \
		install -O root -G system -M 644 -f $(MANDIR)/man1 doc/$(NAME).1; \
		install -O root -G system -M 600 -c $(SYSCONFDIR) doc/$(NAME).conf; \
	else \
		install -D -o root -g root -m 755 -s $(NAME) $(BINDIR)/$(NAME); \
		install -D -o root -g root -m 644 doc/$(NAME).1 $(MANDIR)/man1/$(NAME).1; \
		[ -f $(SYSCONFDIR)/$(NAME).conf -o -z "$(SYSCONFDIR)" ] \
			|| install -D -o root -g root -m 600 doc/$(NAME).conf $(SYSCONFDIR)/$(NAME).conf; \
	fi
	@echo; echo "Cntlm will look for configuration in $(SYSCONFDIR)/$(NAME).conf"

rpm:
	if [ `id -u` = 0 ]; then \
		redhat/rules binary; \
		redhat/rules clean; \
	else \
		fakeroot redhat/rules binary; \
		fakeroot redhat/rules clean; \
	fi

tgz:
	mkdir -p tmp
	rm -f tmp/$(NAME)-$(VER)
	ln -s $(DIR) tmp/$(NAME)-$(VER)
	sed "s/^\./$(NAME)-$(VER)/" doc/files.txt | tar zchf $(NAME)-$(VER).tar.gz --no-recursion -C tmp -T -
	rm tmp/$(NAME)-$(VER)
	rmdir tmp 2>/dev/null || true

win:
	groff -t -e -mandoc -Tps doc/cntlm.1 | ps2pdf - win32/cntlm_manual.pdf
	cat doc/cntlm.conf | unix2dos > win32/cntlm.ini
	cp /bin/cygwin1.dll /bin/cygrunsrv.exe win32/
	strip cntlm.exe
	cp cntlm.exe win32/
	rm -f cntlm-install
	ln -s win32 cntlm-install
	zip -r cntlm-$(VER)-win32.zip cntlm-install -x *.svn/*
	rm -f cntlm-install cntlm-$(VER)-win32.zip.sig

uninstall:
	rm -f $(BINDIR)/$(NAME) $(MANDIR)/man1/$(NAME).1 2>/dev/null || true

clean:
	@rm -f *.o cntlm cntlm.exe configure-stamp build-stamp config/config.h 2>/dev/null
	@rm -f cntlm-install win32/cyg* win32/cntlm* 2>/dev/null
	@rm -f config/endian config/gethostname config/strdup config/socklen_t config/*.exe
	@if [ -h Makefile ]; then rm -f Makefile; mv Makefile.gcc Makefile; fi

cleanp: clean
	@rm -f *.deb *.tgz *.tar.gz *.rpm *.o tags cntlm pid massif* callgrind* 2>/dev/null

distclean: clean
	if [ `id -u` = 0 ]; then \
		redhat/rules clean; \
	else \
		fakeroot redhat/rules clean; \
	fi

## cntlm 0.91~rc6

=== Makefile ===
#
# You can tweak these three variables to make things install where you
# like, but do not touch more unless you know what you are doing. ;)
#
DESTDIR=
SYSCONFDIR=$(DESTDIR)/etc
BINDIR=$(DESTDIR)/usr/sbin
MANDIR=$(DESTDIR)/usr/share/man

#
# Careful now...
# __BSD_VISIBLE is for FreeBSD AF_* constants
# _ALL_SOURCE is for AIX 5.3 LOG_PERROR constant
#
NAME=cntlm
CC=gcc
VER=`cat VERSION`
OBJS=utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o
CFLAGS=$(FLAGS) -std=c99 -Wall -pedantic -O3 -D__BSD_VISIBLE -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112 -D_ISOC99_SOURCE -D_REENTRANT -DVERSION=\"`cat VERSION`\" -g
OS=$(shell uname -s)
OSLDFLAGS=$(shell [ $(OS) = "SunOS" ] && echo "-lrt -lsocket -lnsl")
LDFLAGS:=-lpthread $(OSLDFLAGS)

$(NAME): configure-stamp $(OBJS)
	@echo "Linking $@"
	@$(CC) $(CFLAGS) -o $@ $(OBJS) $(LDFLAGS)

main.o: main.c
	@echo "Compiling $<"
	@if [ -z "$(SYSCONFDIR)" ]; then \
		$(CC) $(CFLAGS) -c main.c -o $@; \
	else \
		$(CC) $(CFLAGS) -DSYSCONFDIR=\"$(SYSCONFDIR)\" -c main.c -o $@; \
	fi

.c.o:
	@echo "Compiling $<"
	@$(CC) $(CFLAGS) -c -o $@ $<

install: $(NAME)
	# AIX?
	if [ -f /usr/bin/oslevel ]; then \
		install -M 755 -S -f $(BINDIR) $(NAME); \
		install -M 644 -f $(MANDIR)/man1 doc/$(NAME).1; \
		install -M 600 -c $(SYSCONFDIR) doc/$(NAME).conf; \
	else \
		install -D -m 755 -s $(NAME) $(BINDIR)/$(NAME); \
		install -D -m 644 doc/$(NAME).1 $(MANDIR)/man1/$(NAME).1; \
		[ -f $(SYSCONFDIR)/$(NAME).conf -o -z "$(SYSCONFDIR)" ] \
			|| install -D -m 600 doc/$(NAME).conf $(SYSCONFDIR)/$(NAME).conf; \
	fi
	@echo; echo "Cntlm will look for configuration in $(SYSCONFDIR)/$(NAME).conf"

tgz:
	mkdir -p tmp
	rm -rf tmp/$(NAME)-$(VER)
	svn export . tmp/$(NAME)-$(VER)
	tar zcvf $(NAME)-$(VER).tar.gz -C tmp/ $(NAME)-$(VER)
	rm -rf tmp/$(NAME)-$(VER)
	rmdir tmp 2>/dev/null || true

tbz2:
	mkdir -p tmp
	rm -rf tmp/$(NAME)-$(VER)
	svn export . tmp/$(NAME)-$(VER)
	tar jcvf $(NAME)-$(VER).tar.bz2 -C tmp/ $(NAME)-$(VER)
	rm -rf tmp/$(NAME)-$(VER)
	rmdir tmp 2>/dev/null || true

deb: builddeb
builddeb:
	sed -i "s/^\(cntlm *\)([^)]*)/\1($(VER))/g" debian/changelog
	if [ `id -u` = 0 ]; then \
		debian/rules binary; \
		debian/rules clean; \
	else \
		fakeroot debian/rules binary; \
		fakeroot debian/rules clean; \
	fi
	mv ../cntlm_$(VER)*.deb .

rpm: buildrpm
buildrpm:
	sed -i "s/^\(Version:[\t ]*\)\(.*\)/\1$(VER)/g" rpm/cntlm.spec
	if [ `id -u` = 0 ]; then \
		rpm/rules binary; \
		rpm/rules clean; \
	else \
		fakeroot rpm/rules binary; \
		fakeroot rpm/rules clean; \
	fi

win: buildwin
buildwin:
	@echo
	@echo "* This build target must be run from a Cywgin shell on Windows *"
	@echo "* and you also need InnoSetup installed                        *"
	@echo
	rm -f win/cntlm_manual.pdf
	groff -t -e -mandoc -Tps doc/cntlm.1 | ps2pdf - win/cntlm_manual.pdf
	cat doc/cntlm.conf | unix2dos > win/cntlm.ini
	cat COPYRIGHT LICENSE | unix2dos > win/license.txt
	sed "s/\$$VERSION/$(VER)/g" win/setup.iss.in > win/setup.iss
	cp /bin/cygwin1.dll /bin/cygrunsrv.exe win/
	cp cntlm.exe win/
	strip win/cntlm.exe
	@echo
	@echo Now open folder "win", right-click "setup.iss", then "Compile".
	@echo InnoSetup will generate a new installer cntlm-X.XX-setup.exe
	@echo

uninstall:
	rm -f $(BINDIR)/$(NAME) $(MANDIR)/man1/$(NAME).1 2>/dev/null || true

clean:
	@rm -f *.o cntlm cntlm.exe configure-stamp build-stamp config/config.h 2>/dev/null
	@rm -f win/*.exe win/*.dll win/*.iss win/*.pdf win/cntlm.ini win/license.txt 2>/dev/null
	@rm -f config/endian config/gethostname config/strdup config/socklen_t config/*.exe
	@if [ -h Makefile ]; then rm -f Makefile; mv Makefile.gcc Makefile; fi

distclean: clean
	if [ `id -u` = 0 ]; then \
		debian/rules clean; \
		rpm/rules clean; \
	else \
		fakeroot debian/rules clean; \
		fakeroot rpm/rules clean; \
	fi
	@rm -f *.exe *.deb *.rpm *.tgz *.tar.gz *.tar.bz2 tags ctags pid 2>/dev/null

## cntlm 0.92.3

=== Makefile ===
--- 
+++ 
@@ -15,11 +15,16 @@
 NAME=cntlm
 CC=gcc
 VER=`cat VERSION`
-OBJS=utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o
-CFLAGS=$(FLAGS) -std=c99 -Wall -pedantic -O3 -D__BSD_VISIBLE -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112 -D_ISOC99_SOURCE -D_REENTRANT -DVERSION=\"`cat VERSION`\" -g
+CFLAGS+=$(FLAGS) -std=c99 -Wall -Wno-unused-but-set-variable -pedantic -O3 -D__BSD_VISIBLE -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112 -D_ISOC99_SOURCE -D_REENTRANT -D_BSD_SOURCE -DVERSION=\"`cat VERSION`\"
 OS=$(shell uname -s)
 OSLDFLAGS=$(shell [ $(OS) = "SunOS" ] && echo "-lrt -lsocket -lnsl")
 LDFLAGS:=-lpthread $(OSLDFLAGS)
+
+ifeq ($(findstring CYGWIN,$(OS)),)
+	OBJS=utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o
+else
+	OBJS=utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o win/resources.o
+endif
 
 $(NAME): configure-stamp $(OBJS)
 	@echo "Linking $@"
@@ -38,11 +43,16 @@
 	@$(CC) $(CFLAGS) -c -o $@ $<
 
 install: $(NAME)
-	# AIX?
-	if [ -f /usr/bin/oslevel ]; then \
+	# Special handling for install(1)
+	if [ "`uname -s`" = "AIX" ]; then \
 		install -M 755 -S -f $(BINDIR) $(NAME); \
 		install -M 644 -f $(MANDIR)/man1 doc/$(NAME).1; \
 		install -M 600 -c $(SYSCONFDIR) doc/$(NAME).conf; \
+	elif [ "`uname -s`" = "Darwin" ]; then \
+		install -d -m 755 -s $(NAME) $(BINDIR)/$(NAME); \
+		install -d -m 644 doc/$(NAME).1 $(MANDIR)/man1/$(NAME).1; \
+		[ -f $(SYSCONFDIR)/$(NAME).conf -o -z "$(SYSCONFDIR)" ] \
+			|| install -d -m 600 doc/$(NAME).conf $(SYSCONFDIR)/$(NAME).conf; \
 	else \
 		install -D -m 755 -s $(NAME) $(BINDIR)/$(NAME); \
 		install -D -m 644 doc/$(NAME).1 $(MANDIR)/man1/$(NAME).1; \
@@ -101,20 +111,27 @@
 	cat doc/cntlm.conf | unix2dos > win/cntlm.ini
 	cat COPYRIGHT LICENSE | unix2dos > win/license.txt
 	sed "s/\$$VERSION/$(VER)/g" win/setup.iss.in > win/setup.iss
-	cp /bin/cygwin1.dll /bin/cygrunsrv.exe win/
+	cp /bin/cygwin1.dll /bin/cyggcc_s-1.dll /bin/cygrunsrv.exe win/
 	cp cntlm.exe win/
 	strip win/cntlm.exe
+	ln -s win $(NAME)-$(VER)
+	zip -9 $(NAME)-$(VER).zip $(NAME)-$(VER)/cntlm.exe $(NAME)-$(VER)/cyggcc_s-1.dll $(NAME)-$(VER)/cygwin1.dll $(NAME)-$(VER)/cygrunsrv.exe $(NAME)-$(VER)/cntlm.ini $(NAME)-$(VER)/README.txt $(NAME)-$(VER)/license.txt
+	rm -f $(NAME)-$(VER)
 	@echo
 	@echo Now open folder "win", right-click "setup.iss", then "Compile".
 	@echo InnoSetup will generate a new installer cntlm-X.XX-setup.exe
 	@echo
+
+win/resources.o: win/resources.rc
+	@echo Adding EXE resources
+	@windres $^ -o $@
 
 uninstall:
 	rm -f $(BINDIR)/$(NAME) $(MANDIR)/man1/$(NAME).1 2>/dev/null || true
 
 clean:
 	@rm -f *.o cntlm cntlm.exe configure-stamp build-stamp config/config.h 2>/dev/null
-	@rm -f win/*.exe win/*.dll win/*.iss win/*.pdf win/cntlm.ini win/license.txt 2>/dev/null
+	@rm -f win/*.exe win/*.dll win/*.iss win/*.pdf win/cntlm.ini win/license.txt win/resouces.o 2>/dev/null
 	@rm -f config/endian config/gethostname config/strdup config/socklen_t config/*.exe
 	@if [ -h Makefile ]; then rm -f Makefile; mv Makefile.gcc Makefile; fi

=== debian/changelog ===
cntlm (0.92.3-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Convert to source format 3.0. Closes: #683640.
  * d/copyright: Convert to machine-readable format.

 -- Bastian Germann <bage@debian.org>  Sun, 18 Feb 2024 16:59:48 +0000

cntlm (0.92.3-1.2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Non-maintainer upload

  [ Graham Inggs ]
  * Cherry-pick r306 from 0.93 to properly handle non-HTTP/1.1 keep-alive
    (LP: #1009436 Closes: #679211)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Apr 2022 15:19:17 +0200

cntlm (0.92.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 13.
      - debian/rules: using 'dh_prep' instead of 'dh_clean -k' because the
        '-k' option is not supported since compat 12.
      - Closes: #965463

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 17 Apr 2022 15:10:54 -0300

cntlm (0.92.3-1) unstable; urgency=low

  * New upstream release. Closes: #652725, #588920.
  * Fix Init script error, thanks Martijn. Closes: #588683.
  * Correct spellings in man page.
  * Update Standards Version, no changes needed.

 -- David Watson <dwatson@debian.org>  Fri, 27 Apr 2012 15:08:17 +0100

cntlm (0.35.1-5) unstable; urgency=low

  * Fix lintian errors in debian/copyright 
  * Update Standards Version, no changes needed.

 -- David Watson <dwatson@debian.org>  Wed, 02 Sep 2009 12:52:32 +0100

cntlm (0.35.1-4) unstable; urgency=low

  * Add set -e to prerm script.
  * Add vcs fields to control.
  * Update Standards Version, no changes needed.

 -- David Watson <dwatson@debian.org>  Fri, 10 Oct 2008 22:00:42 +0100

cntlm (0.35.1-3) unstable; urgency=low

  * Added watch file, thanks Kumar Appaiah. Closes: #471173. 

 -- David Watson <dwatson@debian.org>  Sat, 22 Mar 2008 01:22:59 +0000

cntlm (0.35.1-2) unstable; urgency=low

  * Fix Dependencies. Closes: #459786.
  * Updated Standards Version, no changes needed.
  * Removed empty directory from package.
  * Fixed hyphens in man page.

 -- David Watson <dwatson@debian.org>  Tue, 08 Jan 2008 23:34:29 +0000

cntlm (0.35.1-1) unstable; urgency=low

  [ David Kubicek ] 
  * New upstream release
  * Updated init script for non-persistent /var/run/cntlm (Ubuntu)
  * Fixed #1835218
  * Support and new test macros for Mac OS
  * Automated ./configure && make system with compiler and arch detection

 -- David Watson <dwatson@debian.org>  Fri, 25 Nov 2007 20:27:45 +0000

cntlm (0.35-1) unstable; urgency=low

  * New upstream release
  * Built-in SOCKS5 proxy service
  * Fixed #1806604 - allow NTLM-free (open) proxy
  * Fixed #1820540 - Ubuntu /bin/sh (Dash) compatible
  * Added __BSD_VISIBLE def for FreeBSD compilation
  * Fixed typo which made tunnels unstable!
  * Major code refactoring

 -- David Kubicek <dave@awk.cz>  Fri, 02 Nov 2007 01:21:46 +0100

cntlm (0.34.1-1) unstable; urgency=low

  * New upstream release
  * Move Homepage field from description

 -- David Watson <dwatson@debian.org>  Tue, 23 Oct 2007 22:02:38 +0100

cntlm (0.33-1) unstable; urgency=low

  * New upstream release

 -- David Watson <dwatson@debian.org>  Tue, 31 Jul 2007 00:53:20 +0100
 

cntlm (0.32-1) unstable; urgency=low

  * New upstream relase
  * Error message on stderr if start is not successful (was only error return code)
  * Updated init scripts not to display possible error message (uses only RC)
  * Feature req #1751349 implemented: NTLM-to-basic with multiuser support
        - can detect wrong password, allowing multiple tries without browser restart
        - builtin "access denied" page

 -- David Kubicek <dave@awk.cz>  Thu, 12 Jul 2007 16:23:20 +0200
 

cntlm (0.31.1-1) unstable; urgency=low

  * New upstream release
  * Full support + fix for chunked encoding (incl. extensions and trailers)

 -- David Kubicek <dave@awk.cz>  Mon, 09 Jul 2007 15:01:43 +0200
 

cntlm (0.31-1) unstable; urgency=low

  * New upstream release
  * Important feature added for HTTP/1.1 clients - chunked TE
  * Major fix for FTP downloads (some didn't work at all)

 -- David Kubicek <dave@awk.cz>  Tue, 05 Jun 2007 09:27:09 +0200

cntlm (0.30-1) unstable; urgency=low

  * New upstream release

 -- David Kubicek <dave@awk.cz>  Fri, 08 Jun 2007 20:50:31 +0200

cntlm (0.29.1-1) unstable; urgency=low

  * New upstream release

 -- David Kubicek <dave@awk.cz>  Tue, 05 Jun 2007 09:27:09 +0200

cntlm (0.29-1) unstable; urgency=low

  * New upstream version

 -- David Kubicek <dave@awk.cz>  Fri, 01 Jun 2007 17:41:23 +0200

cntlm (0.28.1-1) unstable; urgency=low

  * Initial release
  * Makefile adjustments regarding installation directories

 -- David Kubicek <dave@awk.cz>  Fri, 01 Jun 2007 17:36:34 +0200

=== debian/control ===
Source: cntlm
Section: net
Priority: optional
Maintainer: David Watson <dwatson@debian.org>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 3.9.3
Vcs-Git: git://planetwatson.co.uk/cntlm
Vcs-Browser: http://projects.planetwatson.co.uk/repositories/show/cntlm
Homepage: http://cntlm.sourceforge.net/

Package: cntlm
Architecture: any
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Replaces: ntlmaps
Description: Fast NTLM authentication proxy with tunneling
 Cntlm is a fast and efficient NTLM proxy, with support for TCP/IP tunneling,
 authenticated connection caching, ACLs, proper daemon logging and behaviour
 and much more. It has up to ten times faster responses than similar NTLM
 proxies, while using by orders or magnitude less RAM and CPU. Manual page 
 contains detailed information.

=== debian/rules ===
#!/usr/bin/make -f
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

#export DH_VERBOSE=1

CFLAGS = -Wall

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	./configure
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/cntlm.
	$(MAKE) DESTDIR=$(CURDIR)/debian/cntlm install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_install
	cp debian/lintian-override debian/cntlm/usr/share/lintian/overrides/cntlm
	dh_installdebconf	
	dh_installinit -n
	dh_installman doc/cntlm.1
	dh_link
	dh_strip
	dh_compress
	dh_fixperms -Xcntlm.conf
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
http://sf.net/cntlm/cntlm-([\.\d]+)\.tar\.gz

## cntlm 0.93.1gss

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
set(CMAKE_VERBOSE_MAKEFILE ON)
project(cntlm C)

include(GNUInstallDirs)

option(ENABLE_KERBEROS "Enable Kerberos support" ON)
option(WITH_GSS_STUB "Build with built-in stub of libgssapi_krb5.so.2 (usefull for cross-compile)" OFF)
option(WITH_SYSTEMD "Generate unit file depend on given version, use -DSYSTEMD_VERSION=<ver> to provide required version" ON)

set(_cflags)
set(_defines)
set(_libs)
set(_includes)

file(READ "VERSION" VERSION)
string(STRIP "${VERSION}" VERSION)

message(STATUS "*** Build ${PROJECT_NAME} ver. ${VERSION}")

# CMAKE_C_BYTE_ORDER: from version 3.20
if(CMAKE_C_BYTE_ORDER STREQUAL "BIG_ENDIAN")
    set(BIG_ENDIAN TRUE)
elseif(CMAKE_C_BYTE_ORDER STREQUAL "LITTLE_ENDIAN")
    set(BIG_ENDIAN FALSE)
else()
    try_run(_big_endian _big_endian_compiled ${CMAKE_BINARY_DIR}/_big_endian
        SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/config/big_endian.c
    )

    if(_big_endian_compiled AND NOT "${_big_endian}" STREQUAL "FAILED_TO_RUN")
        if(${_big_endian} EQUAL 0)
            set(BIG_ENDIAN TRUE)
        else()
            set(BIG_ENDIAN FALSE)
        endif()
    else()
        message(FATAL_ERROR "Cannot detect byte order, CMAKE_C_BYTE_ORDER='${CMAKE_C_BYTE_ORDER}' and big_endian test FAILED_TO_RUN!")
    endif()
endif()

if (CMAKE_VERSION VERSION_LESS "3.1")
    if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
        set (CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
    endif ()
else ()
    set (CMAKE_C_STANDARD 99)
endif ()

include(CheckSymbolExists)
include(CheckTypeSize)
check_symbol_exists("strdup" "string.h" HAVE_STRDUP)
check_symbol_exists("gethostname" "unistd.h" HAVE_GETHOSTNAME)

list(APPEND CMAKE_EXTRA_INCLUDE_FILES "sys/socket.h")
check_type_size("socklen_t" HAVE_SOCKLEN_T)

configure_file(config.h.in config.h)
list(APPEND _includes ${CMAKE_BINARY_DIR})

if(NOT DEFINED SYSCONF_INSTALL_DIR)
    set(SYSCONF_INSTALL_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}")
endif()

configure_file(doc/cntlm.conf.in ${CMAKE_BINARY_DIR}/cntlm.conf @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/cntlm.conf DESTINATION ${SYSCONF_INSTALL_DIR})

include(cmake/systemd.cmake)

install(FILES
    README README.md COPYRIGHT LICENSE doc/cntlm.conf
    DESTINATION ${CMAKE_INSTALL_DOCDIR}
)
install(FILES
    doc/cntlm.1
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
)

find_package(Threads REQUIRED)
list(APPEND _libs ${CMAKE_THREAD_LIBS_INIT})

set(_sources
    utils.c ntlm.c xcrypt.c config-file.c socket.c acl.c auth.c http.c forward.c direct.c scanner.c pages.c
    main.c
)

if(ENABLE_KERBEROS)
    message(STATUS "*** With Kerberos support enabled")
    list(APPEND _sources kerberos.c)

    if(NOT WITH_GSS_STUB)
        message(STATUS "*** using system mit-krb5-gssapi")
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(KRB5GSSAPI REQUIRED mit-krb5-gssapi)
        list(APPEND _cflags ${KRB5GSSAPI_CFLAGS_OTHER})
        list(APPEND _includes ${KRB5GSSAPI_INCLUDE_DIRS})
        list(APPEND _libs ${KRB5GSSAPI_LIBRARIES})
    else()
        message(STATUS "*** using gssapi-stub")
        add_subdirectory(gssapi-stub)
        list(APPEND _includes gssapi-stub)
        list(APPEND _libs gssapi_krb5_stub)
    endif()
endif()

list(APPEND _cflags -Wall -Wextra -Werror)
if (NOT (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_LESS "6.0"))
    list(APPEND _cflags -Wpedantic)
endif()

add_executable(${PROJECT_NAME} ${_sources})
target_link_libraries(${PROJECT_NAME} ${_libs})
target_include_directories(${PROJECT_NAME} PRIVATE ${_includes})
target_compile_options(${PROJECT_NAME} PRIVATE ${_cflags})
target_compile_definitions(${PROJECT_NAME} PRIVATE ${_defines})

set_target_properties(${PROJECT_NAME}
    PROPERTIES
        SKIP_BUILD_RPATH TRUE
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_SBINDIR})

install(FILES doc/add-user-keytab.sh
    DESTINATION ${CMAKE_INSTALL_SBINDIR}
    RENAME "cntlm-keytab-install"
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== Makefile ===
--- 
+++ 
@@ -14,25 +14,52 @@
 #
 NAME=cntlm
 CC=gcc
-VER=`cat VERSION`
-CFLAGS+=$(FLAGS) -std=c99 -Wall -Wno-unused-but-set-variable -pedantic -O3 -D__BSD_VISIBLE -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112 -D_ISOC99_SOURCE -D_REENTRANT -D_BSD_SOURCE -DVERSION=\"`cat VERSION`\"
+VER := $(shell cat VERSION)
+
+VERBOSE ?= 0
+ifeq ($(VERBOSE),1)
+V:=
+else
+V:=@
+endif
+
+
+DEBUG ?= 0
+ifeq ($(DEBUG),1)
+CFLAGS+=$(FLAGS) -O0 -g
+else
+CFLAGS+=$(FLAGS) -O3
+endif
+
+CFLAGS+=$(FLAGS) -std=c99 -Wall -Wno-unused-but-set-variable -pedantic -D__BSD_VISIBLE -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112 -D_ISOC99_SOURCE -D_REENTRANT -D_DEFAULT_SOURCE -DVERSION=\"$(VER)\"
+
 OS=$(shell uname -s)
 OSLDFLAGS=$(shell [ $(OS) = "SunOS" ] && echo "-lrt -lsocket -lnsl")
 LDFLAGS:=-lpthread $(OSLDFLAGS)
 
 ifeq ($(findstring CYGWIN,$(OS)),)
-	OBJS=utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o
+	OBJS=utils.o ntlm.o xcrypt.o config-file.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o
 else
-	OBJS=utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o win/resources.o
+	OBJS=utils.o ntlm.o xcrypt.o config-file.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o main.o win/resources.o
 endif
+
+ENABLE_KERBEROS=$(shell grep -c ENABLE_KERBEROS config.h)
+ifeq ($(ENABLE_KERBEROS),1)
+	OBJS+=kerberos.o
+	LDFLAGS+=-lgssapi_krb5
+endif
+
+#CFLAGS+=-g
+
+all: $(NAME)
 
 $(NAME): configure-stamp $(OBJS)
 	@echo "Linking $@"
-	@$(CC) $(CFLAGS) -o $@ $(OBJS) $(LDFLAGS)
+	$(V)$(CC) $(CFLAGS) -o $@ $(OBJS) $(LDFLAGS)
 
 main.o: main.c
 	@echo "Compiling $<"
-	@if [ -z "$(SYSCONFDIR)" ]; then \
+	$(V)if [ -z "$(SYSCONFDIR)" ]; then \
 		$(CC) $(CFLAGS) -c main.c -o $@; \
 	else \
 		$(CC) $(CFLAGS) -DSYSCONFDIR=\"$(SYSCONFDIR)\" -c main.c -o $@; \
@@ -40,7 +67,7 @@
 
 .c.o:
 	@echo "Compiling $<"
-	@$(CC) $(CFLAGS) -c -o $@ $<
+	$(V)$(CC) $(CFLAGS) -c -o $@ $<
 
 install: $(NAME)
 	# Special handling for install(1)
@@ -124,16 +151,16 @@
 
 win/resources.o: win/resources.rc
 	@echo Adding EXE resources
-	@windres $^ -o $@
+	$(V)windres $^ -o $@
 
 uninstall:
 	rm -f $(BINDIR)/$(NAME) $(MANDIR)/man1/$(NAME).1 2>/dev/null || true
 
 clean:
-	@rm -f *.o cntlm cntlm.exe configure-stamp build-stamp config/config.h 2>/dev/null
-	@rm -f win/*.exe win/*.dll win/*.iss win/*.pdf win/cntlm.ini win/license.txt win/resouces.o 2>/dev/null
-	@rm -f config/endian config/gethostname config/strdup config/socklen_t config/*.exe
-	@if [ -h Makefile ]; then rm -f Makefile; mv Makefile.gcc Makefile; fi
+	$(V)rm -f *.o cntlm cntlm.exe configure-stamp build-stamp config.h 2>/dev/null
+	$(V)rm -f win/*.exe win/*.dll win/*.iss win/*.pdf win/cntlm.ini win/license.txt win/resouces.o 2>/dev/null
+	$(V)rm -f config/big_endian config/have_gethostname config/have_socklen_t config/have_strdup config/*.exe
+	$(V)if [ -h Makefile ]; then rm -f Makefile; mv Makefile.gcc Makefile; fi
 
 distclean: clean
 	if [ `id -u` = 0 ]; then \
@@ -143,4 +170,4 @@
 		fakeroot debian/rules clean; \
 		fakeroot rpm/rules clean; \
 	fi
-	@rm -f *.exe *.deb *.rpm *.tgz *.tar.gz *.tar.bz2 tags ctags pid 2>/dev/null
+	$(V)rm -f *.exe *.deb *.rpm *.tgz *.tar.gz *.tar.bz2 tags ctags pid 2>/dev/null

=== gssapi-stub/CMakeLists.txt ===
### stub library build
add_library(gssapi_krb5_stub SHARED libgssapi_krb5-stub.c)

set(SONAME "libgssapi_krb5.so.2")

set_property(TARGET gssapi_krb5_stub PROPERTY NO_SONAME TRUE)
set_property(TARGET gssapi_krb5_stub APPEND_STRING
    PROPERTY
        LINK_FLAGS " -Wl,-soname,${SONAME}"
)

=== debian/changelog ===
cntlm (0.93.1gss-1+1.16) unstable; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Tue, 30 Sep 2025 23:33:23 +0000

cntlm (0.35.1-1) unstable; urgency=low 

  [ David Kubicek ] 
  * New upstream release
  * Updated init script for non-persistent /var/run/cntlm (Ubuntu)
  * Fixed #1835218
  * Support and new test macros for Mac OS
  * Automated ./configure && make system with compiler and arch detection

 -- David Watson <dwatson@debian.org>  Fri, 25 Nov 2007 20:27:45 +0000

cntlm (0.92.3) unstable; urgency=low

  * Ad-hoc source build, not a Debian maintained package!

 -- David Kubicek <dave@awk.cz>  Fri, 14 Mar 2010 02:16:39 +0100

=== debian/control ===
Source: cntlm
Section: net
Priority: optional
Maintainer: Emil Biserov <biserov@gmail.com>
Build-Depends: debhelper (>= 9), dh-autoreconf, cmake, pkg-config
Standards-Version: 3.9.3
Homepage: https://github.com/biserov/cntlm-gss/

Package: cntlm
Architecture: any
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Replaces: ntlmaps
Description: Fast NTLM/Kerberos authentication proxy with tunneling
 Cntlm is a fast and efficient NTLM proxy, with support for TCP/IP tunneling,
 authenticated connection caching, ACLs, proper daemon logging and behaviour
 and much more. It has up to ten times faster responses than similar NTLM
 proxies, while using by orders or magnitude less RAM and CPU. Manual page 
 contains detailed information.

=== debian/rules ===
--- 
+++ 
@@ -18,8 +18,15 @@
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
+
 	# Add here commands to configure the package.
-	./configure
+	mkdir .build
+	cd .build && cmake \
+	    -DCMAKE_BUILD_TYPE="Release" \
+	    -DCMAKE_INSTALL_PREFIX="/" \
+	    -DSYSCONF_INSTALL_DIR="/etc" \
+	    -DSYSTEMD_INSTALL_DIR="/lib/systemd/system" \
+	    ..
 	touch configure-stamp
 
 build: build-arch build-indep
@@ -30,8 +37,7 @@
 	dh_testdir
 
 	# Add here commands to compile the package.
-	$(MAKE)
-
+	cd .build && cmake --build .
 	touch $@
 
 clean:
@@ -40,7 +46,7 @@
 	rm -f build-stamp configure-stamp
 
 	# Add here commands to clean up after the build process.
-	[ ! -f Makefile ] || $(MAKE) clean
+	rm -rf .build
 
 	dh_clean 
 
@@ -51,7 +57,7 @@
 	dh_installdirs
 
 	# Add here commands to install the package into debian/cntlm.
-	$(MAKE) DESTDIR=$(CURDIR)/debian/cntlm install
+	cd .build && env DESTDIR=$(CURDIR)/debian/cntlm cmake --install .
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -64,14 +70,17 @@
 	dh_installchangelogs 
 	dh_installdocs
 	dh_install
-	cp debian/lintian-override debian/cntlm/usr/share/lintian/overrides/cntlm
-	dh_installdebconf	
+	#install -d debian/cntlm/usr/share/lintian/overrides
+	#install debian/lintian-override debian/cntlm/usr/share/lintian/overrides/cntlm
+	dh_installdebconf
 	dh_installinit -n
 	dh_installman doc/cntlm.1
 	dh_link
 	dh_strip
 	dh_compress
 	dh_fixperms -Xcntlm.conf
+	dh_fixperms
+	dh_installsystemd --restart-after-upgrade cntlm.service || true
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

## cntlm 0.94.0%2Bdfsg

=== debian/control ===
Source: cntlm
Section: net
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/cntlm
Vcs-Git: https://salsa.debian.org/debian/cntlm.git
Homepage: https://github.com/versat/cntlm/

Package: cntlm
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Replaces: ntlmaps
Description: Fast NTLM authentication proxy with tunneling
 Cntlm is a fast and efficient NTLM proxy, with support for TCP/IP tunneling,
 authenticated connection caching, ACLs, proper daemon logging and behaviour
 and much more. It has up to ten times faster responses than similar NTLM
 proxies, while using by orders or magnitude less RAM and CPU. Manual page
 contains detailed information.

## cntlm 0.94.0+dfsg

=== Makefile ===
#
# You can tweak these three variables to make things install where you
# like, but do not touch more unless you know what you are doing. ;)
#
DESTDIR    	:=
PREFIX     	:= /usr/local
SYSCONFDIR 	:= $(DESTDIR)/etc
BINDIR     	:= $(DESTDIR)$(PREFIX)/sbin
MANDIR     	:= $(DESTDIR)$(PREFIX)/share/man

STAMP	:= configure-stamp
ifeq ($(wildcard $(STAMP)),)
_ := $(shell ./configure)
endif

#
# Careful now...
# __BSD_VISIBLE is for FreeBSD AF_* constants
# _ALL_SOURCE is for AIX 5.3 LOG_PERROR constant
#
NAME		:= cntlm
CC		:= $(shell head -n 1 $(STAMP))
VER		:= $(shell cat VERSION)
OS		:= $(shell uname -s)
OSLDFLAGS	:= $(shell [ $(OS) = "SunOS" ] && echo "-lrt -lsocket -lnsl")
LDFLAGS		:= -lpthread -lm $(OSLDFLAGS)
CYGWIN_REQS	:= cygwin1.dll cygrunsrv.exe

ifeq ($(CC),gcc)
GCC_VER := $(shell ${CC} -dumpfullversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/')
GCC_GTEQ_430 := $(shell expr ${GCC_VER} \>= 40300)
GCC_GTEQ_450 := $(shell expr ${GCC_VER} \>= 40500)
GCC_GTEQ_600 := $(shell expr ${GCC_VER} \>= 60000)
GCC_GTEQ_700 := $(shell expr ${GCC_VER} \>= 70000)
endif

CFLAGS	+= -std=c99 -D__BSD_VISIBLE -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112 -D_ISOC99_SOURCE -D_REENTRANT -D_BSD_SOURCE -D_DEFAULT_SOURCE -D_DARWIN_C_SOURCE -DVERSION=\"'$(VER)'\"
CFLAGS	+= -Wall -Wextra -pedantic -Wshadow -Wcast-qual -Wbad-function-cast -Wstrict-prototypes -Wno-overlength-strings
CFLAGS	+= -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=1
#CFLAGS  += -ftrapv
#CFLAGS  += -fsanitize=undefined -fsanitize-undefined-trap-on-error

ifeq ($(CC),gcc)
ifeq "$(GCC_GTEQ_430)" "1"
	CFLAGS += -Wlogical-op
endif
ifeq "$(GCC_GTEQ_450)" "1"
	CFLAGS += -Wjump-misses-init
endif
ifeq "$(GCC_GTEQ_600)" "1"
	CFLAGS += -Wduplicated-cond
	CFLAGS += -Wnull-dereference
	CFLAGS += -Werror=uninitialized
	CFLAGS += -Wformat=2
	CFLAGS += -Wformat-overflow=2
	CFLAGS += -Wformat-truncation=2
	CFLAGS += -Wformat-security
endif
ifeq "$(GCC_GTEQ_700)" "1"
	CFLAGS += -Wduplicated-branches
endif
endif

#CFLAGS	+= -fstack-protector-strong
#CFLAGS	+= -v
ifeq ($(COVERAGE),1)
	# COVERAGE REPORT
	CFLAGS  += -g --coverage
else ifeq ($(DEBUG),1)
	# DEBUG
	CFLAGS	+= -g -O0
else
	# RELEASE
	CFLAGS	+= -O3
endif

OBJS=main.o utils.o ntlm.o xcrypt.o config.o socket.o acl.o auth.o http.o forward.o direct.o scanner.o pages.o proxy.o pac.o duktape.o

CONFIG_GSS=$(shell grep -c "config_gss 1" config/config.h)
ifeq ($(CONFIG_GSS),1)
	OBJS+=kerberos.o
ifeq ($(OS),Darwin)
	LDFLAGS+=-framework GSS
else
	LDFLAGS+=-lgssapi_krb5
endif
endif

ifneq ($(findstring CYGWIN,$(OS)),)
	OBJS+=sspi.o win/resources.o
endif

ENABLE_STATIC=$(shell grep -c ENABLE_STATIC config/config.h)
ifeq ($(ENABLE_STATIC),1)
        LDFLAGS+=-static
endif

CFLAGS_DUKTAPE := -Wno-bad-function-cast -Wno-null-dereference -Wno-format-nonliteral -Wno-unused-but-set-variable
ifeq ($(CC),gcc)
	CFLAGS_DUKTAPE += -Wno-format-overflow 
endif

all: $(NAME)

$(NAME): $(OBJS)
	@echo "Linking $@"
	@$(CC) $(CFLAGS) -o $@ $(OBJS) $(LDFLAGS)

main.o: main.c
	@echo "Compiling $<"
	@if [ -z "$(SYSCONFDIR)" ]; then \
		$(CC) $(CFLAGS) -c main.c -o $@; \
	else \
		$(CC) $(CFLAGS) -DSYSCONFDIR=\"$(SYSCONFDIR)\" -c main.c -o $@; \
	fi

%.o: %.c
	@echo "Compiling $<"
	@$(CC) $(CFLAGS) -c -o $@ $<

duktape.o: duktape/duktape.c
	@echo "Compiling $<"
	@$(CC) $(CFLAGS) $(CFLAGS_DUKTAPE) -c -o $@ $<

win/resources.o: win/resources.rc
	@echo Win64: adding ICON resource
	@windres $^ -o $@

install: $(NAME)
	# Special handling for install(1)
	if [ "`uname -s`" = "AIX" ]; then \
		install -M 755 -S -f $(BINDIR) $(NAME); \
		install -M 644 -f $(MANDIR)/man1 doc/$(NAME).1; \
		install -M 600 -c $(SYSCONFDIR) doc/$(NAME).conf; \
	elif [ "`uname -s`" = "Darwin" ]; then \
		install -d $(BINDIR)/; \
		install -m 755 -s $(NAME) $(BINDIR)/$(NAME); \
		install -d $(MANDIR)/man1/; \
		install -m 644 doc/$(NAME).1 $(MANDIR)/man1/$(NAME).1; \
		[ -f $(SYSCONFDIR)/$(NAME).conf -o -z "$(SYSCONFDIR)" ] \
			|| install -d $(SYSCONFDIR)/; \
			   install -m 600 doc/$(NAME).conf $(SYSCONFDIR)/$(NAME).conf; \
	else \
		install -D -m 755 -s $(NAME) $(BINDIR)/$(NAME); \
		install -D -m 644 doc/$(NAME).1 $(MANDIR)/man1/$(NAME).1; \
		[ -f $(SYSCONFDIR)/$(NAME).conf -o -z "$(SYSCONFDIR)" ] \
			|| install -D -m 600 doc/$(NAME).conf $(SYSCONFDIR)/$(NAME).conf; \
	fi
	@echo; echo "Cntlm will look for configuration in $(SYSCONFDIR)/$(NAME).conf"

tgz:
	mkdir -p tmp
	rm -rf tmp/$(NAME)-$(VER)
	git checkout-index -a -f --prefix=./tmp/$(NAME)-$(VER)/
	tar zcvf $(NAME)-$(VER).tar.gz -C tmp/ $(NAME)-$(VER)
	rm -rf tmp/$(NAME)-$(VER)
	rmdir tmp 2>/dev/null || true

tbz2:
	mkdir -p tmp
	rm -rf tmp/$(NAME)-$(VER)
	git checkout-index -a -f --prefix=./tmp/$(NAME)-$(VER)/
	tar jcvf $(NAME)-$(VER).tar.bz2 -C tmp/ $(NAME)-$(VER)
	rm -rf tmp/$(NAME)-$(VER)
	rmdir tmp 2>/dev/null || true

deb:
	sed -i "s/^\(cntlm *\)([^)]*)/\1($(VER))/g" debian/changelog
	if [ `id -u` = 0 ]; then \
		debian/rules binary; \
		debian/rules clean; \
	else \
		fakeroot debian/rules binary; \
		fakeroot debian/rules clean; \
	fi
	mv ../cntlm_$(VER)*.deb .

rpm:
	sed -i "s/^\(Version:[\t ]*\)\(.*\)/\1$(VER)/g" rpm/cntlm.spec
	if [ `id -u` = 0 ]; then \
		rpm/rules binary; \
		rpm/rules clean; \
	else \
		fakeroot rpm/rules binary; \
		fakeroot rpm/rules clean; \
	fi

win: win/setup.iss $(NAME) win/cntlm_manual.pdf win/cntlm.ini win/LICENSE.txt $(NAME)-$(VER)-win64.exe $(NAME)-$(VER)-win64.zip

$(NAME)-$(VER)-win64.exe:
	@echo Win64: preparing binaries for GUI installer
	@cp $(patsubst %, /bin/%, $(CYGWIN_REQS)) win/
ifeq ($(DEBUG),1)
	@echo Win64: copy DEBUG executable
	@cp -p cntlm.exe win/
else
	@echo Win64: copy release executable
	@strip -o win/cntlm.exe cntlm.exe
endif
	@echo Win64: generating GUI installer
	@win/Inno5/ISCC.exe /Q win/setup.iss #/Q win/setup.iss

$(NAME)-$(VER)-win64.zip:
	@echo Win64: creating ZIP release for manual installs
	@ln -s win $(NAME)-$(VER)
	zip -9 $@ $(patsubst %, $(NAME)-$(VER)/%, cntlm.exe $(CYGWIN_REQS) cntlm.ini LICENSE.txt cntlm_manual.pdf)
	@rm -f $(NAME)-$(VER)

win/cntlm.ini: doc/cntlm.conf
	@cat doc/cntlm.conf | unix2dos > $@

win/LICENSE.txt: COPYRIGHT LICENSE
	@cat COPYRIGHT LICENSE | unix2dos > $@

win/cntlm_manual.pdf: doc/cntlm.1
	@echo Win64: generating PDF manual
	@rm -f $@
	@groff -t -e -mandoc -Tps doc/cntlm.1 | ps2pdf - $@

win/setup.iss: win/setup.iss.in
ifeq ($(findstring CYGWIN,$(OS)),)
	@echo
	@echo "* This build target must be run from a Cywgin shell on Windows *"
	@echo
	@exit 1
endif
	@sed "s/\$$VERSION/$(VER)/g" $^ > $@

uninstall:
	rm -f $(BINDIR)/$(NAME) $(MANDIR)/man1/$(NAME).1 2>/dev/null || true

clean:
	@rm -f config/endian config/gethostname config/socklen_t config/strdup config/arc4random_buf config/strlcat config/strlcpy config/memset_s config/gss config/*.exe
	@rm -f *.o cntlm cntlm.exe configure-stamp build-stamp config/config.h
	@rm -f $(patsubst %, win/%, $(CYGWIN_REQS) cntlm.exe cntlm.ini LICENSE.txt resources.o setup.iss cntlm_manual.pdf)

distclean: clean
ifeq ($(findstring CYGWIN,$(OS)),)
	if [ `id -u` = 0 ]; then \
		debian/rules clean; \
		rpm/rules clean; \
	else \
		fakeroot debian/rules clean; \
		fakeroot rpm/rules clean; \
	fi
endif
	@rm -f *.exe *.deb *.rpm *.tgz *.tar.gz *.tar.bz2 *.zip *.exe tags ctags pid 2>/dev/null

.PHONY: all install tgz tbz2 deb rpm win uninstall clean distclean

=== debian/changelog ===
cntlm (0.94.0+dfsg-1) unstable; urgency=medium

  * QA upload.

  [ Andreas Tille ]
  * New upstream version
    Closes: #679216, #1009006
  * Orphan package
    Closes: #1112090
  * Point Homepage to Github
  * d/watch: Fix watch file
  * d/rules:
     - Its not a sample
     - Short dh
  * d/copyright:
     - review
     - Files-Excluded: win rpm
  * Rename d/lintian-override to d/cntlm.lintian-overrides
  * debian/dirs: removed
  * Standards-Version: 4.7.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Update lintian override info format in d/sntlm.lintian-overrides on line 2
  * Fix day-of-week for changelog entry 0.35.1-1.
  * Add debian/upstream/metadata
  * Rotate cntlm logs
    Closes: #1004332
  * Drop manually edited sections from maintainer scripts
  * Add systemd unit
    Closes: #1039151
  * Permit failure of blhc in Salsa CI

  [ Alessandro Casale ]
  * Use LSB logging function in init script
    Closes: #730699

 -- Andreas Tille <tille@debian.org>  Mon, 06 Oct 2025 16:00:42 +0200

=== debian/rules ===
#!/usr/bin/make -f
#

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	# ./configure is not created by autoconf
	./configure

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_fixperms:
	dh_fixperms -X/etc/cntlm.conf

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,repacksuffix=+dfsg,dversionmangle=auto" \
   https://github.com/versat/cntlm/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

#opts="mode=git,pretty=0.94~git%cd.%h,repacksuffix=+dfsg,dversionmangle=auto" \
#    https://github.com/versat/cntlm.git HEAD

# Issue asking for release tags:
# https://github.com/versat/cntlm/issues/126
